# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name_x86 = 'vcredist_x86.exe'
bin_name_x64 = 'vcredist_x64.exe'
silent_args = '/Q'
uninstall_key_x86 = '{710f4c1c-cc18-4c49-8cbf-51240c89a1a2}'
uninstall_key_x64 = '{ad8a2fa1-06e7-4b0d-927d-6e54b3d31028}'
url_dl_x86 = 'https://download.microsoft.com/download/8/B/4/8B42259F-5D70-43F4-AC2E-4B208FD8D66A/vcredist_x86.exe'
url_dl_x64 = 'https://download.microsoft.com/download/8/B/4/8B42259F-5D70-43F4-AC2E-4B208FD8D66A/vcredist_x64.exe'
short_soft_name = 'Microsoft Visual C++ 2005 Redistributable'


def install():
    print('installing %s' % control.asrequirement())

    # Specific app values
    package_version = control.version.split('-',1)[0]

    # Uninstalling older versions
    check_installed = installed_softwares(short_soft_name)
    #print(check_installed)
    for uninstall in check_installed:
        if uninstall['version'] < package_version:
            print('Removing %s' % uninstall['name'])
            cmd = uninstall_cmd(uninstall['key'])
            run(cmd)

    # Getting the used storage on programfiles before installation (place it on the top)
    get_disk_free_space_before = get_disk_free_space(programfiles)

    # Installing the package
    install_exe_if_needed(bin_name_x86
        ,silentflags=silent_args
        ,key=uninstall_key_x86
        ,min_version=package_version)

    if iswin64():
        install_exe_if_needed(bin_name_x64
            ,silentflags=silent_args
            ,key=uninstall_key_x64
            ,min_version=package_version)

   	# Return used storage of the program. (place it on the bottom)
    get_disk_free_space_after = get_disk_free_space(programfiles)
    free_space_after_diff = get_disk_free_space_before - get_disk_free_space_after
    print("Storage used: " + str(free_space_after_diff))


def update_package():
    print('Update/Download package content from upstream binary sources')

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(application_data(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Downloading binaries
    if not isfile(bin_name_x86):
        print('Downloading ' + bin_name_x86)
        wget(url_dl_x86,bin_name_x86,proxies=proxy)

    if not isfile(bin_name_x64):
        print('Downloading ' + bin_name_x64)
        wget(url_dl_x64,bin_name_x64,proxies=proxy)

